--------------------------------------------------------
--  DDL for Procedure EST_TOTAL_DESC
--------------------------------------------------------
set define off;

  CREATE OR REPLACE PROCEDURE "EST_TOTAL_DESC" (
    RSP OUT NVARCHAR2)
  -- PROCEDIMENT          EST_TOTAL_DESC
  --
  -- AQUEST PROCEDIMENT MOSTRA PER PANTALLA EL TOTAL DE DESCARREGUES REALITZADES
  -- A LA PLATAFORMA CONSULTANT A LA TAULA D'ESTADISTIQUES GENERALS.
  --
  -- PARAMETRES D'ENTRADA:
  -- PARAMETRES DE SORTIDA: RSP NVARCHAR2(RESULTAT DE L'EXECUCIO DEL PROCEDIMENT)
  --
  -- VALORS DE RSP: 'OK'
  --                'ERROR' + MOTIU DE L'ERROR
  --
  -- ERRORS POSSIBLES:
  --
  --                  ALTRES
AS
  -- VARIABLES TEMPORALS
  N EST_GEN.NUMDESC%TYPE;
  -- VARIABLES PER A LA TAULA DE LOG
  ENTRADA PLOG.ENTRADA%TYPE;
  PROCEDIMENT PLOG.PROCEDIMENT%type DEFAULT 'EST_TOTAL_DESC';
BEGIN
  -- DESA ELS PARAMETRES D'ENTRADA PER A LA TAULA DE LOG
  ENTRADA:=NULL;
  -- CONSULTA LA TAULA D'ESTADISTIQUES GENERALS PER A VEURE EL TOTAL DE DESCARREGUES
  SELECT NUMDESC
  INTO N
  FROM EST_GEN;
  -- ES MOSTRA PER PANTALLA EL RESULTAT
 SYS.DBMS_OUTPUT.PUT_LINE('EL NOMBRE DE DESCARREGUES TOTALS A LA PLATAFORMA ES: '||N);
  -- S'HA REALITZAR EL PROCEDIMENT CORRECTAMENT
  RSP:='OK';
  -- GUARDA A LA TAULA DE LOG
  INSERT
  INTO PLOG VALUES
    (
      PROCEDIMENT,
      ENTRADA ,
      RSP,
      CURRENT_DATE
    );
  --CONFIRMEM ELS CANVIS FETS A LA BASE DE DADES DURANT L'EXECUCIO DEL PROCEDIMENT.
  COMMIT;
EXCEPTION
WHEN OTHERS THEN
  RSP:='ERROR: SENSE TRACTAR. PROCEDIMENT '||PROCEDIMENT||' - '||SQLCODE||'-'||SQLERRM;
  -- GUARDA A LA TAULA DE LOG
  INSERT
  INTO PLOG VALUES
    (
      PROCEDIMENT,
      ENTRADA ,
      RSP,
      CURRENT_DATE
    );
  --CONFIRMEM ELS CANVIS FETS A LA BASE DE DADES DURANT L'EXECUCIO DEL PROCEDIMENT.
  COMMIT;
END EST_TOTAL_DESC;
/
