drop trigger t_des;
drop table so cascade constraints;
drop table modepag cascade constraints;
drop table operador cascade constraints;
drop table pais cascade constraints;
drop table model cascade constraints;
drop table usuari cascade constraints;
drop table aplicacio cascade constraints;
drop table dispositiu cascade constraints;
drop table descarrega cascade constraints;
drop table descripcio cascade constraints;
drop table desenvolupador cascade constraints;
drop table desenvolupada cascade constraints;
drop table soapl cascade constraints;
drop table preupais cascade constraints;
drop table est_gen cascade constraints;
drop table est_anual cascade constraints;
drop table est_anual_local cascade constraints;
drop table plog cascade constraints;

CREATE TABLE  "SO" 
   (	"IDSO" NUMBER(*,0) NOT NULL ENABLE, 
	"NOMSO" NVARCHAR2(30) NOT NULL ENABLE, 
	 PRIMARY KEY ("IDSO") ENABLE
   )
/
CREATE TABLE  "MODEPAG" 
   (	"MODP" NUMBER(*,0) NOT NULL ENABLE, 
	"DESP" NVARCHAR2(10) NOT NULL ENABLE, 
	 PRIMARY KEY ("MODP") ENABLE
   )
/
CREATE TABLE  "OPERADOR" 
   (	"IDOPER" NUMBER(*,0) NOT NULL ENABLE, 
	"NOMOPER" NVARCHAR2(30) NOT NULL ENABLE, 
	 PRIMARY KEY ("IDOPER") ENABLE
   )
/
CREATE TABLE  "PAIS" 
   (	"IDPAIS" NVARCHAR2(2) NOT NULL ENABLE, 
	"NOMPAIS" NVARCHAR2(50) NOT NULL ENABLE, 
	 PRIMARY KEY ("IDPAIS") ENABLE
   )
/
CREATE TABLE  "MODEL" 
   (	"MODELMOB" NVARCHAR2(20) NOT NULL ENABLE, 
	"RESX" NUMBER(*,0) NOT NULL ENABLE, 
	"RESY" NUMBER(*,0) NOT NULL ENABLE, 
	"IDSO" NUMBER NOT NULL ENABLE, 
	 PRIMARY KEY ("MODELMOB") ENABLE, 
	 CONSTRAINT "MODEL_CHK1" CHECK (RESX > 0) ENABLE, 
	 CONSTRAINT "MODEL_CHK2" CHECK (RESY > 0) ENABLE, 
	 CONSTRAINT "MODEL_SO_FK1" FOREIGN KEY ("IDSO")
	  REFERENCES  "SO" ("IDSO")  ENABLE
   )
/
CREATE TABLE  "USUARI" 
   (	"NUMMOB" NUMBER(11,0) NOT NULL ENABLE, 
	"CORREUUS" NVARCHAR2(60), 
	"IDOPER" NUMBER(*,0) NOT NULL ENABLE, 
	"PAIS" NVARCHAR2(2) NOT NULL ENABLE, 
	 PRIMARY KEY ("NUMMOB") ENABLE, 
	 CONSTRAINT "USUARI_OPERADOR_FK1" FOREIGN KEY ("IDOPER")
	  REFERENCES  "OPERADOR" ("IDOPER") ENABLE, 
	 CONSTRAINT "USUARI_PAIS_FK1" FOREIGN KEY ("PAIS")
	  REFERENCES  "PAIS" ("IDPAIS")  ENABLE
   )
/
CREATE TABLE  "APLICACIO" 
   (	"IDAPL" NUMBER(*,0) NOT NULL ENABLE, 
	"NOMAPL" NVARCHAR2(30) NOT NULL ENABLE, 
	"VERSIO" NVARCHAR2(12) NOT NULL ENABLE, 
	"DATAUP" DATE NOT NULL ENABLE, 
	"VIDEODEMO" NVARCHAR2(70), 
	"MINRESX" NUMBER(*,0) NOT NULL ENABLE, 
	"MINRESY" NUMBER(*,0) NOT NULL ENABLE, 
	"ACTIVA" NVARCHAR2(1) DEFAULT 'I' NOT NULL ENABLE, 
	 PRIMARY KEY ("IDAPL") ENABLE, 
	 CONSTRAINT "NOM_APL_UNIC" UNIQUE ("NOMAPL") ENABLE
   )
/

CREATE TABLE  "DISPOSITIU" 
   (	"IMEI" NUMBER(*,0) NOT NULL ENABLE, 
	"MODELMOB" NVARCHAR2(20) NOT NULL ENABLE, 
	"NUMMOB" NUMBER(11,0), 
	 PRIMARY KEY ("IMEI") ENABLE, 
	 CONSTRAINT "DISPOSITIU_MODEL_FK1" FOREIGN KEY ("MODELMOB")
	  REFERENCES  "MODEL" ("MODELMOB") ENABLE, 
	 CONSTRAINT "DISPOSITIU_USUARI_FK1" FOREIGN KEY ("NUMMOB")
	  REFERENCES  "USUARI" ("NUMMOB") ON DELETE SET NULL ENABLE
   )
/
CREATE TABLE  "DESCARREGA" 
   (	"IMEI" NUMBER(*,0) NOT NULL ENABLE, 
	"IDAPL" NUMBER(*,0) NOT NULL ENABLE, 
	"MODEP" NUMBER(*,0) NOT NULL ENABLE, 
	"IDOPER" NUMBER(*,0) NOT NULL ENABLE, 
	"DATDES" DATE NOT NULL ENABLE, 
	"PREU" NUMBER(*,2) NOT NULL ENABLE, 
	"IDPAIS" NVARCHAR2(2) NOT NULL ENABLE, 
	"VERSIO" NVARCHAR2(12) NOT NULL ENABLE, 
	"INST" NVARCHAR2(1), 
	 PRIMARY KEY ("IDAPL", "IMEI") ENABLE, 
	 CONSTRAINT "DESCARREGA_APLICACIO_FK1" FOREIGN KEY ("IDAPL")
	  REFERENCES  "APLICACIO" ("IDAPL") ON DELETE CASCADE ENABLE, 
	 CONSTRAINT "DESCARREGA_DISPOSITIU_FK1" FOREIGN KEY ("IMEI")
	  REFERENCES  "DISPOSITIU" ("IMEI") ON DELETE CASCADE ENABLE, 
	 CONSTRAINT "DESCARREGA_MODEPAG_FK1" FOREIGN KEY ("MODEP")
	  REFERENCES  "MODEPAG" ("MODP")  ENABLE, 
	 CONSTRAINT "DESCARREGA_OPERADOR_FK1" FOREIGN KEY ("IDOPER")
	  REFERENCES  "OPERADOR" ("IDOPER")  ENABLE, 
	 CONSTRAINT "DESCARREGA_PAIS_FK1" FOREIGN KEY ("IDPAIS")
	  REFERENCES  "PAIS" ("IDPAIS")  ENABLE
   )
/
CREATE TABLE  "DESCRIPCIO" 
   (	"IDAPL" NUMBER(*,0) NOT NULL ENABLE, 
	"IDIOMA" NVARCHAR2(20) NOT NULL ENABLE, 
	"DESCR" NVARCHAR2(2000) NOT NULL ENABLE, 
	 PRIMARY KEY ("IDAPL", "IDIOMA") ENABLE, 
	 CONSTRAINT "DESCRIPCIO_APLICACIO_FK1" FOREIGN KEY ("IDAPL")
	  REFERENCES  "APLICACIO" ("IDAPL") ON DELETE CASCADE ENABLE
   )
/
CREATE TABLE  "DESENVOLUPADOR" 
   (	"IDDES" NUMBER(*,0) NOT NULL ENABLE, 
	"NOMDES" NVARCHAR2(30) NOT NULL ENABLE, 
	"NOMREP" NVARCHAR2(60) NOT NULL ENABLE, 
	"IDPAIS" NVARCHAR2(2) NOT NULL ENABLE, 
	"TELDES" NUMBER(11,0) NOT NULL ENABLE, 
	"ADRECADES" NVARCHAR2(200), 
	 PRIMARY KEY ("IDDES") ENABLE, 
	 CONSTRAINT "DESENVOLUPADOR_CHK1" CHECK (TELDES > 0) ENABLE, 
	 CONSTRAINT "DESENVOLUPADOR_UK1" UNIQUE ("TELDES") ENABLE, 
	 CONSTRAINT "DESENVOLUPADOR_UK2" UNIQUE ("NOMDES") ENABLE, 
	 CONSTRAINT "DESENVOLUPADOR_UK3" UNIQUE ("ADRECADES") ENABLE, 
	 CONSTRAINT "DESENVOLUPADOR_PAIS_FK1" FOREIGN KEY ("IDPAIS")
	  REFERENCES  "PAIS" ("IDPAIS") ENABLE
   )
/
CREATE TABLE  "DESENVOLUPADA" 
   (	"IDAPL" NUMBER(*,0) NOT NULL ENABLE, 
	"IDDES" NUMBER(*,0) NOT NULL ENABLE, 
	 PRIMARY KEY ("IDAPL", "IDDES") ENABLE, 
	 CONSTRAINT "DESENVOLUPADA_APLICACIO_FK1" FOREIGN KEY ("IDAPL")
	  REFERENCES  "APLICACIO" ("IDAPL") ON DELETE CASCADE ENABLE, 
	 CONSTRAINT "DESENVOLUPADA_DESENVOLUPA_FK1" FOREIGN KEY ("IDDES")
	  REFERENCES  "DESENVOLUPADOR" ("IDDES") ON DELETE CASCADE ENABLE
   )
/
CREATE TABLE  "EST_ANUAL" 
   (	"ANYC" NUMBER(*,0) NOT NULL ENABLE, 
	"MITJADESC" NUMBER(*,2), 
	"DESENVOLUPADOR" NUMBER(*,0), 
	"APLICACIO" NUMBER(*,0), 
	"DESDES" NUMBER(*,0), 
	 PRIMARY KEY ("ANYC") ENABLE, 
	 CONSTRAINT "EST_ANUAL_APLICACIO_FK1" FOREIGN KEY ("APLICACIO")
	  REFERENCES  "APLICACIO" ("IDAPL") ON DELETE SET NULL ENABLE, 
	 CONSTRAINT "EST_ANUAL_DESENVOLUPADOR_FK1" FOREIGN KEY ("DESENVOLUPADOR")
	  REFERENCES  "DESENVOLUPADOR" ("IDDES") ON DELETE SET NULL ENABLE
   )
/
CREATE TABLE  "EST_ANUAL_LOCAL" 
   (	"ANYC" NUMBER(*,0) NOT NULL ENABLE, 
	"PAIS" NVARCHAR2(2) NOT NULL ENABLE, 
	"NUSUARIS" NUMBER(*,0) NOT NULL ENABLE, 
	"INGRESSOS" NUMBER(*,2) NOT NULL ENABLE, 
	"NAPLICACIONS" NUMBER(*,0) NOT NULL ENABLE, 
	 PRIMARY KEY ("ANYC", "PAIS") ENABLE, 
	 CONSTRAINT "EST_ANUAL_LOCAL_PAIS_FK1" FOREIGN KEY ("PAIS")
	  REFERENCES  "PAIS" ("IDPAIS") ON DELETE CASCADE ENABLE
   )
/
CREATE TABLE  "EST_GEN" 
   (	"NUMDESC" NUMBER(*,0) NOT NULL ENABLE, 
	"EUROSDESC" NUMBER(*,2) NOT NULL ENABLE, 
	 PRIMARY KEY ("NUMDESC") ENABLE
   )
/
CREATE TABLE  "PLOG" 
   (	"PROCEDIMENT" NVARCHAR2(20) NOT NULL ENABLE, 
	"ENTRADA" NVARCHAR2(400), 
	"SORTIDA" NVARCHAR2(500) NOT NULL ENABLE, 
	"DATA" TIMESTAMP (6) WITH LOCAL TIME ZONE NOT NULL ENABLE
   )
/
CREATE TABLE  "PREUPAIS" 
   (	"IDAPL" NUMBER(*,0) NOT NULL ENABLE, 
	"IDPAIS" NVARCHAR2(2) NOT NULL ENABLE, 
	"PREU" NUMBER(*,2) NOT NULL ENABLE, 
	 PRIMARY KEY ("IDAPL", "IDPAIS") ENABLE, 
	 CONSTRAINT "PREUPAIS_APLICACIO_FK1" FOREIGN KEY ("IDAPL")
	  REFERENCES  "APLICACIO" ("IDAPL") ON DELETE CASCADE ENABLE, 
	 CONSTRAINT "PREUPAIS_PAIS_FK1" FOREIGN KEY ("IDPAIS")
	  REFERENCES  "PAIS" ("IDPAIS") ON DELETE CASCADE ENABLE
   )
/
CREATE TABLE  "SOAPL" 
   (	"IDAPL" NUMBER(*,0) NOT NULL ENABLE, 
	"IDSO" NUMBER(*,0) NOT NULL ENABLE, 
	"MIDA" NUMBER(*,0) NOT NULL ENABLE, 
	"BIN" NVARCHAR2(160) NOT NULL ENABLE, 
	 PRIMARY KEY ("IDAPL", "IDSO") ENABLE, 
	 CONSTRAINT "SOAPL_APLICACIO_FK2" FOREIGN KEY ("IDAPL")
	  REFERENCES  "APLICACIO" ("IDAPL") ON DELETE CASCADE ENABLE, 
	 CONSTRAINT "SOAPL_SO_FK1" FOREIGN KEY ("IDSO")
	  REFERENCES  "SO" ("IDSO") ON DELETE CASCADE ENABLE
   )
/

CREATE OR REPLACE TRIGGER  "T_DES" AFTER
  INSERT OR
  UPDATE OR
  DELETE ON DESCARREGA
    -- DISPARADOR T_DES
    --
    -- AQUEST DISPARADOR S'ENCARREGA QUE LES ESTADISTIQUES GENERALS ESTIGUIN ACTUALITZADES
    -- CADA COP QUE ES MODIFICA LA TAULA DESCARREGUES
    DECLARE
    -- VARIABLES TEMPORALS
    PREU DESCARREGA.PREU%TYPE DEFAULT 0;
  NDES NUMBER;
  N    NUMBER;
  BEGIN
    -- COMPROVA QUE HI HAGI REGISTRE A LA TAULA DE ESTADISTIQUES GENERALS
    SELECT COUNT(*)
    INTO N
    FROM EST_GEN;
    -- INSERTA EL REGISTRE A LA TAULA D'ESTADISTIQUES GENERALS
    IF (N=0)THEN
      INSERT INTO EST_GEN VALUES
        (0,0
        );
    END IF;
    -- ACTUALITZA EL COMPTADOR DE LES ESTADISTIQUES GENERALS
    SELECT SUM(DESCARREGA.PREU),
      COUNT(*)
    INTO PREU,
      NDES
    FROM DESCARREGA
    WHERE INST='I';
    IF (NDES IS NULL) THEN
      NDES   :=0;
    END IF;
    IF (preu IS NULL) THEN
      preu   :=0;
    END IF;
    UPDATE EST_GEN
    SET EST_GEN.EUROSDESC=PREU,
      EST_GEN.NUMDESC    =NDES
    WHERE rownum         = 1;
  END;
/
ALTER TRIGGER  "T_DES" ENABLE
/
